#pragma options align=packed
#define NDESCS 104
#include <sys/types.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#define unsign(x) if (x < 0) x += 256

struct Descs
{
  short int shIndex;
  short int shScale;
  long int liRef;
  short int shWidth;
}
  sDescs[NDESCS] =
{
  1,    0,   0,  10,
  2,    0,   0,  11,
  3,    0,   0, 160,
  4,    0,   0,  96,
  5,    0,   0,  11,
  6,    0,   0,  24,
  7,    0,   0, 128,
  8,    0,   0,  12,
  9,    0,   0,   4,
  10,   0,   0,   6,
  11,   0,   0,   5,
  12,   0,   0,   6,
  13,   6,   0,  26,
  14,   5, -9000000, 25,
  15,   5, -18000000, 26,
  16,   0,   0,   8,
  17,   0,   0,   2,
  18,   0,   0,   7,

  19,   0,   0,   8,
  20,   0,   0,   4,
  21,   0,   0,   2,
  22,   0,   0,   9,
  23,   0,   0,   9,
  24,   0,   0,   2,
  25,   0,   0,   5,
  26,   0,   0,   8,
  27,   0,   0,   3,
  28,   0,   0,   2,

  29,   0,   0,   5,
  30,   0,   0,   3,
  31,   0,   0,   2,

  32,	3,   0,  31,
  33,	3,   0,  16,
  34,	0,   0,  10,
  35,	4, -120000, 18,
  36,   3, -32768, 16,

  37,   3,   0,  16,
  38,   3,   0,  16,
  39,   0,   0,  10,
  40,   3, -1000, 11,

  41,   2, -32768, 16,
  42,   2, -32768, 16,
  43,   0,   0,  10,
  44,   2, -2048, 12,
  45,   2, -10000, 14,

  46,   2,   0,  13,
  47,   2,   0,   8,
  48,   0,   0,   5,

  49,   3,   0,  31,
  50,   3,   0,  16,
  51,   0,   0,  10,
  52,   4, -120000, 18,
  53,   4, -6000,  13,

  54,   3,   0,  16,
  55,   3,   0,  16,
  56,   0,   0,  10,
  57,   3, -1000, 11,

  58,   2, -32768, 16,
  59,   2, -32768, 16,
  60,   0,   0,  10,
  61,   2, -2048, 12,
  62,   2, -10000, 14,

  63,   2,   0,  13,
  64,   2,   0,   9,
  65,   0,   0,  10,

  66,  -8,   0,  26,
  67,   1,   0,  12,
  68,  -8,   0,  26,
  69,   1,   0,  12,
  70,  -8,   0,  26,
  71,   1,   0,  12,
  72,   1,   0,  10,
  73,   2,   0,   8,

  74,  -1, -40,  16,
  75,   2,   0,  12,
  76,   2,   0,  12,
  77,  -1, -40,  16,
  78,   1, -4096, 13,
  79,   1, -4096, 13,

  80,   3, -131072,  18,
  81,   3,   0,  31,
  82,   3, -65536, 17,
  83,   2,   0,  16,
  84,   2, -32768, 16,
  85,   3, -32768, 16,
  86,   3, -32768, 16,
  87,   3, -32768, 16,
  88,   3, -32768, 16,
  89,   4, -5000, 13,

  90,   3, -131072, 18,
  91,   3, -131072, 18,
  92,   3, -131072, 18,
  93,   1, -131072, 18,
  94,   3, -32768, 16,
  95,   3, -32768, 16,
  96,   3, -32768, 16,
  97,   4, -2000, 12,
  98,   4, -2000, 12,
  99,   3, -32768, 16,
  100,   4, -2000, 12,
  101,   3, -32768, 16,
  102,   3, -32768, 16,
  103,   4, -3000, 13,
  104,   3, -32768, 16
};

struct JASON2OGDRData
{ 
  unsigned short int usiSatId;
  unsigned short int usiSatInstr;
  char azAqunStatnId[20];
  char azSoftwareId[12];
  unsigned long int uliOrbit;
  unsigned long int uliSatCycle;
  char azModelNum[16];
  short int shYear;
  short int shMonth;
  short int shDay;
  short int shHour;
  short int shMinute;
  short int shSecond;
  float fLatitude;
  float fLongitude;
  unsigned char ucSurf;
  unsigned char ucAltEch;
  unsigned char ucRadSurf;
  unsigned short int usiInterpFlag;
  unsigned short int usiOrbitFlag;
  unsigned short int usiAltimStFlag;
  unsigned short int usiAltimDQFlag;
  unsigned short int usiAltimCQFlag;
  unsigned short int usiAltRainFlag;
  unsigned short int usiRadStatFlag;
  unsigned short int usiRadDQuaFlag;
  unsigned short int usiRadBTInFlag;
  unsigned short int usiIceFlag;
  unsigned char ucAuxAltStatFlg;
  unsigned char ucMetMapAvl;
  unsigned char ucMDTInterpFlaf;
  float fRangeKu;
  float fRMSRanKu;
  float fNumRanKu;
  float fInstCorrKu;
  float fSSBCorrKu;
  float fSWHKu;
  float fRMSSWHKu;
  float fNumSWHKu;
  float fInstCorrSWHKu;
  float fSig0Ku;
  float fRMSSig0Ku;
  float fNumSig0Ku;
  float fInstCorrSig0Ku;
  float fAtCorrSig0Ku;
  float fAGCKu;
  float fRMSAGCKu;
  float fNumAGCKu;
  float fRangeC;
  float fRMSRanC;
  float fNumRanC;
  float fInstCorrC;
  float fSSBCorrC;
  float fSWHC;
  float fRMSSWHC;
  float fNumSWHC;
  float fInstCorrSWHC;
  float fSig0C;
  float fRMSSig0C;
  float fNumSig0C;
  float fInstCorrSig0C;
  float fAtCorrSig0C;
  float fAGCC;
  float fRMSAGCC;
  float fNumAGCC;
  float fBT187;
  float fBT238;
  float fBT340;
  float fRadWV;
  float fRadLW;
  float fWSpdAlt;
  float fWSpdRad;
  float fWSpdMU;
  float fWSpdMV;
  float fMeanDynTop;
  float fHeight;
  float fInstAltR;
  float fOffNadPtf; 
  float fOffNadWv;
  float fModIonCor;
  float fAltIonCor;
  float fMDryTCor;
  float fMWetTCor;
  float fRadWetTCor;
  float fMSS;
  float fMSSAlt;
  float fGeoid;
  float fBathy;
  float fSolidTide;
  float fGeoTide1;
  float fGeoTide2;
  float fLoadTide1;
  float fLoadTide2;
  float fOcTideEq;
  float fOcTideNonEq;
  float fPoleTide;
  float fInvBath;
  float fHfFluc;
  float fSSHA;
};

int main(int argc, char *argv[])
{
  FILE *fpInputFile;
  struct stat stFileStat;
  char *pzWholeFile;
  char *pzOneBulletin;
  char *pzFormat;
  struct JASON2OGDRData *psData;
  long int liFileSize;
  long int liBulLen;
  long int liLoop;
  long int liSect1Offset, liSect1Length;
  long int liSect2Offset, liSect2Length;
  long int liSect3Offset, liSect3Length;
  long int liSect4Offset, liSect4Length;
  long int liSect5Offset, liSect5Length;
  int iState;
  long int liNumberN, liNumberO, liNumberP, liNumberQ;
  long int liNumberR, liNumberS, liNumberT, liNumberU;
  long int liTotSubSets;
  long int liSubSet;
  unsigned long int uliWorkBits;
  unsigned long long ullToilBits;
  short int shEdition;
  short int shMasterTab;
  short int shGenSubCen;
  short int shGenCentre;
  short int shUpdateSeq;
  short int shOptnSect2;
  short int shDataCateg;
  short int shSubCateg;
  short int shMastrVers;
  short int shLocalVers;
  short int shYear;
  short int shMonth;
  short int shDay;
  short int shHour;
  short int shMinute;
  short int shSecond;
  short int shObAndComp;
  short int shCompress;
  short int shSect3F, shSect3X, shSect3Y;
  short int shNProblems = 0;
  short int shElement;
  long int liR0;
  float fR0, fValue;
  short int shNBINC;
  long int liStartByte;
  short int shStartBit;
  long int liEndByte;
  short int shEndBit;
  long int liByteInc, liOrigByte;
  short int shBitDec, shOrigBit;
  short int shLocScale;
  long int liLocRef;
  short int shLocWidth;
  static char *stpzMonth[] = {"DummyShift","January","February","March","April",
    "May","June","July","August","September","October","November","December"};

  if (argc != 2)
  {
    (void)printf("Wrong number of arguments: %d, there should be 1.\n", --argc);
    return 1;
  }

  (void)stat(*(argv + 1), &stFileStat);
  liFileSize = (long int)stFileStat.st_size;

  pzWholeFile = (char *)malloc((size_t)liFileSize);

  if ((fpInputFile = fopen(*(argv + 1), "r")) == NULL)
  {
    (void)printf("Cant open file, %s\n", *(argv + 1));
    return 2;
  }

  iState = fread((void *)pzWholeFile, (size_t)liFileSize, 1, fpInputFile);
  if (iState == 0) printf("Problem reading input file into memory.\n");

  iState = fclose(fpInputFile);
  if (iState != 0) printf("Ploblem closing input file.\n");

  /* Section 0 */
  (void)printf("\nSection 0\n=========\n");

  pzFormat = (char *)malloc((size_t)5);
  (void)memcpy(pzFormat, pzWholeFile, 4);
  *(pzFormat + 4) = NULL;
  (void)printf("Data format: %s\n",pzFormat); 

  liNumberS = *(pzWholeFile + 4); unsign(liNumberS);
  liNumberT = *(pzWholeFile + 5); unsign(liNumberT);
  liNumberU = *(pzWholeFile + 6); unsign(liNumberU);
  liBulLen = (liNumberS * 256 * 256) + (liNumberT * 256) + liNumberU;
  (void)printf("Total message length: %d\n", liBulLen);

  shEdition = *(pzWholeFile + 7); unsign(shEdition);
  (void)printf("BUFR Edition number: %d\n", shEdition);

  liSect1Offset = 8;

  /* Section 1 */
  (void)printf("\nSection 1\n=========\n");

  liNumberS = *(pzWholeFile + liSect1Offset); unsign(liNumberS);
  liNumberT = *(pzWholeFile + liSect1Offset + 1); unsign(liNumberT);
  liNumberU = *(pzWholeFile + liSect1Offset + 2); unsign(liNumberU);
  liSect1Length = (liNumberS * 256 * 256) + (liNumberT * 256) + liNumberU;
  (void)printf("Length of section: %d\n", liSect1Length);

  shMasterTab = *(pzWholeFile + liSect1Offset + 3); unsign(shMasterTab);
 (void)printf("BUFR master table: %d\n", shMasterTab);


  liNumberT = *(pzWholeFile + liSect1Offset + 4); unsign(liNumberT);
  liNumberU = *(pzWholeFile + liSect1Offset + 5); unsign(liNumberU);
  shGenCentre = (liNumberT * 256) + liNumberU;
 (void)printf("Generating centre: %d%s\n", shGenCentre,
    (254==shGenCentre)?" [EUMETSAT]":" ");

  liNumberT = *(pzWholeFile + liSect1Offset + 6); unsign(liNumberT);
  liNumberU = *(pzWholeFile + liSect1Offset + 7); unsign(liNumberU);
  shGenSubCen = (liNumberT * 256) + liNumberU;
 (void)printf("Generating sub-centre: %d\n", shGenSubCen);

  shUpdateSeq = *(pzWholeFile + liSect1Offset + 8); unsign(shUpdateSeq);
 (void)printf("Undate sequence number: %d\n", shUpdateSeq);

  shOptnSect2 = *(pzWholeFile + liSect1Offset + 9); unsign(shOptnSect2);
  shOptnSect2 = (shOptnSect2&0200)>>7;
 (void)printf("Section 2 indicator: %s.\n",shOptnSect2?"Present":"Omitted");

  shDataCateg = *(pzWholeFile + liSect1Offset + 10); unsign(shDataCateg);
 (void)printf("Data category: %d\n", shDataCateg);

  shSubCateg = *(pzWholeFile + liSect1Offset + 11); unsign(shSubCateg);
 (void)printf("International data sub-category: %d\n", shSubCateg);

  shSubCateg = *(pzWholeFile + liSect1Offset + 12); unsign(shSubCateg);
 (void)printf("Local data sub-category: %d\n", shSubCateg);

  shMastrVers = *(pzWholeFile + liSect1Offset + 13); unsign(shMastrVers);
 (void)printf("Master table version: %d\n", shMastrVers);

  shLocalVers = *(pzWholeFile + liSect1Offset + 14); unsign(shLocalVers);
 (void)printf("Local table version: %d\n", shLocalVers);

  liNumberT = *(pzWholeFile + liSect1Offset + 15); unsign(liNumberT);
  liNumberU = *(pzWholeFile + liSect1Offset + 16); unsign(liNumberU);
  shYear = (liNumberT * 256) + liNumberU;
 (void)printf("Year: %d\n", shYear);

  shMonth = *(pzWholeFile + liSect1Offset + 17); unsign(shMonth);

  shDay = *(pzWholeFile + liSect1Offset + 18); unsign(shDay);

  shHour = *(pzWholeFile + liSect1Offset + 19); unsign(shHour);

  shMinute = *(pzWholeFile + liSect1Offset + 20); unsign(shMinute);

  shSecond = *(pzWholeFile + liSect1Offset + 21); unsign(shSecond);

 (void)printf("Date: %s %2.2d\n", stpzMonth[shMonth], shDay);
 (void)printf("Time: %2.2d:%2.2d:%2.2d\n", shHour, shMinute, shSecond);

  liSect2Offset = (liSect1Offset + liSect1Length);

  /* Section 2 */
  if (!shOptnSect2)
  {
    liSect2Length = 0;
  }
  else
  {
    (void)printf("\nSection 2\n=========\n");
    liNumberS = *(pzWholeFile + liSect2Offset); unsign(liNumberS);
    liNumberT = *(pzWholeFile + liSect2Offset + 1); unsign(liNumberT);
    liNumberU = *(pzWholeFile + liSect2Offset + 2); unsign(liNumberU);
    liSect2Length = (liNumberS * 256 * 256) + (liNumberT * 256) + liNumberU;
    (void)printf("Length of section: %d\n", liSect2Length);
  }

  liSect3Offset = (liSect2Offset + liSect2Length);

  /* Section 3 */
  (void)printf("\nSection 3\n=========\n");

  liNumberS = *(pzWholeFile + liSect3Offset); unsign(liNumberS);
  liNumberT = *(pzWholeFile + liSect3Offset + 1); unsign(liNumberT);
  liNumberU = *(pzWholeFile + liSect3Offset + 2); unsign(liNumberU);
  liSect3Length = (liNumberS * 256 * 256) + (liNumberT * 256) + liNumberU;
  (void)printf("Length of section: %d\n", liSect3Length);

  liNumberT = *(pzWholeFile + liSect3Offset + 4); unsign(liNumberT);
  liNumberU = *(pzWholeFile + liSect3Offset + 5); unsign(liNumberU);
  liTotSubSets = (liNumberT * 256) + liNumberU;
  (void)printf("Number of subsets: %d\n", liTotSubSets);

  shObAndComp = *(pzWholeFile + liSect3Offset + 6); unsign(shObAndComp);
  if (((shObAndComp&0200)>>7) == 1)
  {
    (void)printf("Data content: Message contains observation data.\n");
  }
  else
  {
    (void)printf("Data content: Message contains \"other\" data.\n");
  }
  shCompress = (shObAndComp&0100)>>6;
  (void)printf("Compression status: Data are %s.\n",
    shCompress?"compressed":"not compressed");

  (void)printf("Descriptor list\n");
  for (liLoop = 1; liLoop <= ((liSect3Length - 8) / 2); liLoop++)
  {
    liNumberT = *(pzWholeFile + liSect3Offset + 7 + ((liLoop - 1) * 2));
    unsign(liNumberT);
    shSect3F = (liNumberT&0300)>>6;
    shSect3X = liNumberT&0077;
    liNumberU = *(pzWholeFile + liSect3Offset + 7 + ((liLoop - 1) * 2) + 1);
    unsign(liNumberU );
    shSect3Y = liNumberU;
    (void)printf("%1d-%2.2d-%3.3d ", shSect3F, shSect3X, shSect3Y);
    switch (shSect3F)
    {
      case 0:
        switch (shSect3X)
        {
          case 1:
            switch (shSect3Y)
            {
              case 7:
                (void)printf("Satellite identifiier.\n");
                break;
              case 31:
                (void)printf("Generating centre.\n");
                break;
              case 32:
                (void)printf("Generating sub-centre.\n");
                break;
              case 33:
                (void)printf("Originating/Generating centre.\n");
                break;
              default:
                (void)printf("***ALERT***: Unrecognised element descriptor.\n");
                shNProblems++;
                break;
            }
            break;
          case 2:
            switch (shSect3Y)
            {
              case 19:
                (void)printf("Satellite instrument.\n");
                break;
              case 20:
                (void)printf("Satellite classification.\n");
                break;
              case 22:
                (void)printf("Computation method.\n");
                break;
              case 23:
                (void)printf("Wind computation method.\n");
                break;
              case 28:
                (void)printf("Segment size (X).\n");
                break;
              case 29:
                (void)printf("Segment size (Y).\n");
                break;
              case 48:
                (void)printf("Satellite sensor indicator.\n");
                break;
              case 121:
                (void)printf("Mean frequency.\n");
                break;
              case 152:
                (void)printf("Satellite instrument.\n");
                break;
              case 153:
                (void)printf("Channel frequency.\n");
                break;
              case 154:
                (void)printf("Channel width.\n");
                break;
              case 166:
                (void)printf("Radiance type.\n");
                break;
              case 167:
                (void)printf("Radiance compn method.\n");
                break;
              case 173:
                (void)printf("Square of off nadir angle.\n");
                break;
              default:
                (void)printf("***ALERT***: Unrecognised element descriptor.\n");
                shNProblems++;
                break;
            }
            break;
          case 4:
            switch (shSect3Y)
            {
              case 1:
                (void)printf("Year.\n");
                break;
              case 2:
                (void)printf("Month.\n");
                break;
              case 3:
                (void)printf("Day.\n");
                break;
              case 4:
                (void)printf("Hour.\n");
                break;
              case 5:
                (void)printf("Minute.\n");
                break;
              case 6:
                (void)printf("Second.\n");
                break;
              case 7:
                (void)printf("Seconds in minute.\n");
                break;
              default:
                (void)printf("***ALERT***: Unrecognised element descriptor.\n");
                shNProblems++;
                break;
            }
            break;
          case 5:
            switch (shSect3Y)
            {
              case 1:
                (void)printf("Fine accuracy latitude.\n");
                break;
              case 21:
                (void)printf("Azimuth.\n");
                break;
              case 22:
                (void)printf("Solar azimuth.\n");
                break;
              case 40:
                (void)printf("Orbit number.\n");
                break;
              case 41:
                (void)printf("Scan line number.\n");
                break;
              case 42:
                (void)printf("Channel number.\n");
                break;
              case 43:
                (void)printf("Field of view number.\n");
                break;
              case 192:
                (void)printf("Y position of centre of gravity.\n");
                break;
              case 193:
                (void)printf("Z position of centre of gravity.\n");
                break;
              default:
                (void)printf("***ALERT***: Unrecognised element descriptor.\n");
                shNProblems++;
                break;
            }
            break;
          case 6:
            switch (shSect3Y)
            {
              case 1:
                (void)printf("Fine accuracy longitude.\n");
                break;
              default:
                (void)printf("***ALERT***: Unrecognised element descriptor.\n");
                shNProblems++;
                break;
            }
            break;
          case 7:
            switch (shSect3Y)
            {
              case 1:
                (void)printf("Height.\n");
                break;
              case 4:
                (void)printf("Height (measured).\n");
                break;
              case 24:
                (void)printf("Satellite zenith angle.\n");
                break;
              case 25:
                (void)printf("Solar zenith angle.\n");
                break;
              default:
                (void)printf("***ALERT***: Unrecognised element descriptor.\n");
                shNProblems++;
                break;
            }
            break;
          case 8:
            switch (shSect3Y)
            {
              case 3:
                (void)printf("Vertical significance (sat).\n");
                break;
              case 12:
                (void)printf("Land/Sea qualifier.\n");
                break;
              case 13:
                (void)printf("Day/night qualifier.\n");
                break;
              case 23:
                (void)printf("First order statistics.\n");
                break;
              case 29:
                (void)printf("Remotely sensed surface type.\n");
                break;
              case 49:
                (void)printf("Number of observations.\n");
                break;
              case 65:
                (void)printf("Sun glint indicator.\n");
                break;
              case 74:
                (void)printf("Altimeter type.\n");
                break;
              case 76:
                (void)printf("Type of band used.\n");
                break;
              default:
                (void)printf("***ALERT***: Unrecognised element descriptor.\n");
                shNProblems++;
                break;
            }
            break;
          case 10:
            switch (shSect3Y)
            {
              case 4:
                (void)printf("Height (coord).\n");
                break;
              default:
                (void)printf("***ALERT***: Unrecognised element descriptor.\n");
                shNProblems++;
                break;
            }
            break;
          case 11:
            switch (shSect3Y)
            {
              case 12:
                (void)printf("10m wind speed.\n");
                break;
              default:
                (void)printf("***ALERT***: Unrecognised element descriptor.\n");
                shNProblems++;
                break;
            }
            break;
          case 12:
            switch (shSect3Y)
            {
              case 1:
                (void)printf("Temperature.\n");
                break;
              case 61:
                (void)printf("Surface temperature.\n");
                break;
              case 63:
                (void)printf("Brightness temperature.\n");
                break;
              case 75:
                (void)printf("Spectral radiance.\n");
                break;
              case 76:
                (void)printf("Radinace.\n");
                break;
              case 101:
                (void)printf("Temperature (fine).\n");
                break;
              case 163:
                (void)printf("Brightness temperature (fine).\n");
                break;
              default:
                (void)printf("***ALERT***: Unrecognised element descriptor.\n");
                shNProblems++;
                break;
            }
            break;
          case 13:
            switch (shSect3Y)
            {
              case 2:
                (void)printf("WV mixing ratio.\n");
                break;
              case 38:
                (void)printf("Superadiabatic indicator.\n");
                break;
              case 90:
                (void)printf("Radiometer water vapour content.\n");
                break;
              case 91:
                (void)printf("Radiometer liquid content.\n");
                break;
              default:
                (void)printf("***ALERT***: Unrecognised element descriptor.\n");
                shNProblems++;
                break;
            }
            break;
          case 14:
            switch (shSect3Y)
            {
              case 46:
                (void)printf("Scaled radiance.\n");
                break;
              case 193:
                (void)printf("Scaled mean radiance.\n");
                break;
              case 194:
                (void)printf("Scaled std devn radiance.\n");
                break;
              default:
                (void)printf("***ALERT***: Unrecognised element descriptor.\n");
                shNProblems++;
                break;
            }
            break;
          case 20:
            switch (shSect3Y)
            {
              case 56:
                (void)printf("Cloud phase.\n");
                break;
              case 81:
                (void)printf("Amount of cloud.\n");
                break;
              case 82:
                (void)printf("Amount cloud free.\n");
                break;
              default:
                (void)printf("***ALERT***: Unrecognised element descriptor.\n");
                shNProblems++;
                break;
            }
            break;
          case 21:
            switch (shSect3Y)
            {
              case 62:
                (void)printf("Backscatter.\n");
                break;
              case 128:
                (void)printf("Valid points per second used.\n");
                break;
              default:
                (void)printf("***ALERT***: Unrecognised element descriptor.\n");
                shNProblems++;
                break;
            }
            break;
          case 22:
            switch (shSect3Y)
            {
              case 7:
                (void)printf("!! JASON1 HELP-HELP!!.\n");
                break;
              case 70:
                (void)printf("Significant wave height.\n");
                break;
              default:
                (void)printf("***ALERT***: Unrecognised element descriptor.\n");
                shNProblems++;
                break;
            }
            break;
          case 25:
            switch (shSect3Y)
            {
              case 51:
                (void)printf("AVHRR channel combination.\n");
                break;
              case 60:
                (void)printf("Software ID.\n");
                break;
              case 70:
                (void)printf("Major frame count.\n");
                break;
              case 85:
                (void)printf("Fraction of clear pixels in HIRS FOV.\n");
                break;
              case 95:
                (void)printf("Altimeter state.\n");
                break;
              case 96:
                (void)printf("Radiometer state.\n");
                break;
              case 97:
                (void)printf("3D orbit error.\n");
                break;
              case 192:
                (void)printf("Start band channel.\n");
                break;
              case 193:
                (void)printf("End band channel.\n");
                break;
              case 194:
                (void)printf("Scale for band.\n");
                break;
              default:
                (void)printf("***ALERT***: Unrecognised element descriptor.\n");
                shNProblems++;
                break;
            }
            break;
          case 31:
            switch (shSect3Y)
            {
              case 0:
                (void)printf("Short replication factor.\n");
                break;
              case 1:
                (void)printf("Delayed replication factor.\n");
                break;
              case 2:
                (void)printf("Extended replication factor.\n");
                break;
              case 21:
                (void)printf("Associated field significance.\n");
                break;
              case 31:
                (void)printf("Data present indicator.\n");
                break;
              default:
                (void)printf("***ALERT***: Unrecognised element descriptor.\n");
                shNProblems++;
                break;
            }
            break;
          case 33:
            switch (shSect3Y)
            {
              case 7:
                (void)printf("Percentage confidence.\n");
                break;
              case 35:
                (void)printf("Quality control method.\n");
                break;
              case 36:
                (void)printf("Nominal confidence threshold.\n");
                break;
              case 60:
                (void)printf("IASI quality flag.\n");
                break;
              case 61:
                (void)printf("IASI quality index.\n");
                break;
              case 62:
                (void)printf("IASI quality index LOC.\n");
                break;
              case 63:
                (void)printf("IASI quality index RAD.\n");
                break;
              case 64:
                (void)printf("IASI quality index SPECT.\n");
                break;
              case 65:
                (void)printf("IASI Sys Tec sonde quality.\n");
                break;
              default:
                (void)printf("***ALERT***: Unrecognised element descriptor.\n");
                shNProblems++;
                break;
            }
            break;
          case 40:
            switch (shSect3Y)
            {
              case 192:
                (void)printf("Cloud formation and height assigment.\n");
                break;
              case 193:
                (void)printf("Instrument detecting clouds.\n");
                break;
              case 194:
                (void)printf("Validation flag for IASI level 1 product.\n");
                break;
              case 195:
                (void)printf("Quality and completeness of retrieval.\n");
                break;
              case 196:
                (void)printf("Retrieval choice indicator.\n");
                break;
              case 197:
                (void)printf("Satellite manoeuvre indicator.\n");
                break;
              case 198:
                (void)printf("Selection of background state.\n");
                break;
              default:
                (void)printf("***ALERT***: Unrecognised element descriptor.\n");
                shNProblems++;
                break;
            }
            break;
          default:
            (void)printf("***ALERT***: Unrecognised element descriptor.\n");
            shNProblems++;
            break;
        }
        break;
      case 1:
        (void)printf("Replicate %d %s %d times.\n", shSect3X, 
          (shSect3X > 1)?"descriptors":"descriptor", shSect3Y);
        break;
      case 2:
        switch (shSect3X)
        {
          case 1:
            switch (shSect3Y)
            {
              case 0:
                (void)printf("Cancel change of width.\n");
                break;
              default:
                (void)printf("Add %d bits to data width.\n",
                  (shSect3Y - 128));
                break;
            }
            break;
          case 2:
            switch (shSect3Y)
            {
              case 0:
                (void)printf("Cancel change of scale.\n");
                break;
              default:
                (void)printf("Add %d to scale.\n",
                  (shSect3Y - 128));
                break;
            }
            break;
          case 4:
            switch (shSect3Y)
            {
              case 0:
                (void)printf("Cancel addition of associated bits.\n");
                break;
              default:
                (void)printf("Precede each element with %d associated bits.\n",
                  shSect3Y);
                break;
            }
            break;
          case 22:
            switch (shSect3Y)
            {
              case 0:
                (void)printf("Quality control information follows.\n");
                break;
              default:
                (void)printf("***ALERT***: Unrecognised operator descriptor.\n");
                shNProblems++;
                break;
            }
            break;
          case 36:
            switch (shSect3Y)
            {
              case 0:
                (void)printf("Data present bit map follows.\n");
                break;
              default:
                (void)printf("***ALERT***: Unrecognised operator descriptor.\n");
                shNProblems++;
                break;
            }
            break;
          case 37:
            switch (shSect3Y)
            {
              case 0:
                (void)printf("e-use previously defined bit map.\n");
                break;
              default:
                (void)printf("***ALERT***: Unrecognised operator descriptor.\n");
                shNProblems++;
                break;
            }
            break;
          default:
            (void)printf("***ALERT***: Unrecognised operator descriptor.\n");
            shNProblems++;
            break;
        }
        break;
      case 3:
        switch (shSect3X)
        {
          case 01:
            switch (shSect3Y)
            {
              case 11:
                (void)printf("Year and Month sequence.\n");
                break;
              case 12:
                (void)printf("Day and hour sequence.\n");
                break;
              default:
                (void)printf("***ALERT***: Unrecognised sequence descriptor.\n");
                shNProblems++;
                break;
            }
            break;
          case 10:
            switch (shSect3Y)
            {
              case  8:
                (void)printf("HIRS report sequence.\n");
                break;
              case  9:
                (void)printf("AMSU-A report sequence.\n");
                break;
              case 10:
                (void)printf("AMSU-B report sequence.\n");
                break;
              case 14:
                (void)printf("Geostationary wind sequence.\n");
                break;
              case 15:
                (void)printf("MTP clear sky radiance sequence.\n");
                break;
              case 16:
                (void)printf("MSG clear sky radiance sequence.\n");
                break;
              default:
                (void)printf("***ALERT***: Unrecognised sequence descriptor.\n");
                shNProblems++;
                break;
            }
            break;
          case 12:
            switch (shSect3Y)
            {
              case 41:
                (void)printf("Altitude sequence.\n");
                break;
              default:
                (void)printf("***ALERT***: Unrecognised sequence descriptor.\n");
                shNProblems++;
                break;
            }
            break;
          case 40:
            switch (shSect3Y)
            {
              case 1:
                (void)printf("Full IASI level 1c sequence.\n");
                break;
              case 2:
                (void)printf("IASI level 1c band defn sequence.\n");
                break;
              case 3:
                (void)printf("IASI level 1c 100 channel radiance sequence.\n");
                break;
              case 4:
                (void)printf("IASI level 1c AVHRR single scene sequence.\n");
                break;
              case 5:
                (void)printf("JASON 2 OGDR.\n");
                break;
              case 10:
                (void)printf("JASON 2 OGDR (now with SSHA).\n");
                break;
              default:
                (void)printf("***ALERT***: Unrecognised sequence descriptor.\n");
                shNProblems++;
                break;
            }
            break;
          case 50:
            switch (shSect3Y)
            {
              case 102:
                (void)printf("Full IASI level 1c sequence.\n");
                break;
              case 103:
                (void)printf("IASI level 1c band defn sequence.\n");
                break;
              case 104:
                (void)printf("IASI level 1c channel radiance sequence.\n");
                break;
              case 106:
                (void)printf("IASI level 1c AVHRR sequence.\n");
                break;
              default:
                (void)printf("***ALERT***: Unrecognised sequence descriptor.\n");
                shNProblems++;
                break;
            }
            break;
          default:
            (void)printf("***ALERT***: Unrecognised sequence descriptor.\n");
            shNProblems++;
            break;
        }
        break;
      default:
        (void)printf("***ALERT***: Unrecognised descriptor type.\n");
        shNProblems++;
        break;
    }  
  }

  liSect4Offset = (liSect3Offset + liSect3Length);

  /* Section 4 */
  (void)printf("\nSection 4\n=========\n");

  liNumberS = *(pzWholeFile + liSect4Offset); unsign(liNumberS);
  liNumberT = *(pzWholeFile + liSect4Offset + 1); unsign(liNumberT);
  liNumberU = *(pzWholeFile + liSect4Offset + 2); unsign(liNumberU);
  liSect4Length = (liNumberS * 256 * 256) + (liNumberT * 256) + liNumberU;
  (void)printf("Length of section: %d\n", liSect4Length);

  if ((shCompress) && (0 == shNProblems))
  {
/* Allocate dynamic memory for JASON2 OGDR data */
    psData = (struct JASON2OGDRData *)
      malloc((size_t)(sizeof(struct JASON2OGDRData) * liTotSubSets));
/* Initialise byte and bit offsets */
    liStartByte = liSect4Offset + 4;
    shStartBit = 1;
    liEndByte = liSect4Offset + 4;
    shEndBit = 1;
    for (shElement = 0; shElement < NDESCS; shElement++)
    {
/* Set reference, scale and width */
      shLocScale = sDescs[shElement].shScale;
      liLocRef = sDescs[shElement].liRef;
      shLocWidth = sDescs[shElement].shWidth;

/* Read reference value (allow up to 64 bits) */
      liNumberN = *(pzWholeFile + liStartByte); unsign(liNumberN);
      liNumberO = *(pzWholeFile + liStartByte + 1); unsign(liNumberO);
      liNumberP = *(pzWholeFile + liStartByte + 2); unsign(liNumberP);
      liNumberQ = *(pzWholeFile + liStartByte + 3); unsign(liNumberQ);
      liNumberR = *(pzWholeFile + liStartByte + 4); unsign(liNumberR);
      liNumberS = *(pzWholeFile + liStartByte + 5); unsign(liNumberS);
      liNumberT = *(pzWholeFile + liStartByte + 6); unsign(liNumberT);
      liNumberU = *(pzWholeFile + liStartByte + 7); unsign(liNumberU);

      ullToilBits = ((unsigned long long)liNumberN * 256 * 256 * 256 * 256 * 256 * 256 * 256) +
                    ((unsigned long long)liNumberO * 256 * 256 * 256 * 256 * 256 * 256) +
                    ((unsigned long long)liNumberP * 256 * 256 * 256 * 256 * 256) +
                    ((unsigned long long)liNumberQ * 256 * 256 * 256 * 256) +
                    ((unsigned long long)liNumberR * 256 * 256 * 256) +
                    ((unsigned long long)liNumberS * 256 * 256) +
                    ((unsigned long long)liNumberT * 256) +
                     (unsigned long long)liNumberU;
      ullToilBits >>= (64 - ((shStartBit + shLocWidth) - 1));
      ullToilBits = ullToilBits &
        ((unsigned long int)
          pow((double)2, (double)(shLocWidth)) - 1);
      liR0 = ullToilBits;
/* Calculate end byte and bit */
      liEndByte = ((liStartByte * 8) + shStartBit +
        (shLocWidth - 1)) / 8;
      shEndBit = ((liStartByte * 8) + shStartBit +
        (shLocWidth - 1)) % 8;
      if (0 == shEndBit)
      {
        shEndBit = 8;
        liEndByte -= 1;
      }
/* Calculate next start byte and bit */
      liStartByte = liEndByte;
      shStartBit = shEndBit + 1;
      if (9 == shStartBit)
      {
        shStartBit = 1;
        liStartByte += 1;
      }
/* Read number of bits per descriptor used (always 6 bits) */
      liNumberT = *(pzWholeFile + liStartByte); unsign(liNumberT);
      liNumberU = *(pzWholeFile + liStartByte + 1); unsign(liNumberU);
      uliWorkBits = ((unsigned long int)liNumberT * 256) +
                     (unsigned long int)liNumberU;
      uliWorkBits >>= (16 - ((shStartBit + 6) - 1));
      uliWorkBits = uliWorkBits &
        ((unsigned long int)pow((double)2, (double)(6)) - 1);
      shNBINC = (short int)uliWorkBits;
/* Calculate end byte and bit */
      liEndByte = ((liStartByte * 8) + shStartBit + (6 - 1)) / 8;
      shEndBit = ((liStartByte * 8) + shStartBit + (6 - 1)) % 8;
      if (0 == shEndBit)
      {
        shEndBit = 8;
        liEndByte -= 1;
      }
/* Calculate next start byte and bit */
      liStartByte = liEndByte;
      shStartBit = shEndBit + 1;
      if (9 == shStartBit)
      {
        shStartBit = 1;
        liStartByte += 1;
      }
/* Display some info */
      (void)printf("Element index [from 0]: %d, Ref: %ld, Bits used: %d\n",
        shElement, liR0, shNBINC);
/* If the bits per incr is 0, all values are the same */
      if (0 == shNBINC)
      {
/* Start with reference value from compression */
        fValue = (float)(liR0);
/* Add reference value from Table B */
        fValue += (float)(liLocRef);
/* Apply scale from Table B */
        fValue /= (float)pow((double)10, (double)(shLocScale));
/* Show value */
        /* (void)printf("All subsets for element [%d] have value: %f\n",
        shElement, fValue); */
/* Fill in header/static info */
        switch (shElement)
        {
        case (0):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].usiSatId = (unsigned short int)fValue;
          break;
        case (1):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].usiSatInstr = (unsigned short int)fValue;
          break;
        case (2):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
          {
            psData[liSubSet].azAqunStatnId[0] = (char)((liR0 & 0XFF000000L) >> 24);
    	    psData[liSubSet].azAqunStatnId[1] = (char)((liR0 & 0X00FF0000L) >> 16);
    	    psData[liSubSet].azAqunStatnId[2] = (char)((liR0 & 0X0000FF00L) >> 8);
    	    psData[liSubSet].azAqunStatnId[3] = (char)(liR0 & 0X000000FFL);
    	    psData[liSubSet].azAqunStatnId[4] = '\0';
          }
          break;
        case (3):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
          {
            psData[liSubSet].azSoftwareId[0] = (char)((liR0 & 0XFF000000L) >> 24);
    	    psData[liSubSet].azSoftwareId[1] = (char)((liR0 & 0X00FF0000L) >> 16);
    	    psData[liSubSet].azSoftwareId[2] = (char)((liR0 & 0X0000FF00L) >> 8);
    	    psData[liSubSet].azSoftwareId[3] = (char)(liR0 & 0X000000FFL);
    	    psData[liSubSet].azSoftwareId[4] = '\0';
          }
          break;
        case (4):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].uliOrbit = (unsigned long int)fValue;
          break;
        case (5):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].uliSatCycle = (unsigned long int)fValue;
          break;
        case (6):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
          {
            psData[liSubSet].azModelNum[0] = (char)((liR0 & 0XFF000000L) >> 24);
    	    psData[liSubSet].azModelNum[1] = (char)((liR0 & 0X00FF0000L) >> 16);
    	    psData[liSubSet].azModelNum[2] = (char)((liR0 & 0X0000FF00L) >> 8);
    	    psData[liSubSet].azModelNum[3] = (char)(liR0 & 0X000000FFL);
    	    psData[liSubSet].azModelNum[4] = '\0';
          }
          break;
        case (7):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].shYear = (unsigned short int)fValue;
          break;
        case (8):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].shMonth = (unsigned short int)fValue;
          break;
        case (9):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].shDay = (unsigned short int)fValue;
          break;
        case (10):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].shHour = (unsigned short int)fValue;
          break;
        case (11):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].shMinute = (unsigned short int)fValue;
          break;
        case (12):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].shSecond = (unsigned short int)fValue;
          break;
        case (13):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fLatitude = fValue;
          break;
        case (14):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fLongitude = fValue;
          break;
        case (15):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].ucSurf = (unsigned char)fValue;
          break;
        case (16):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].ucAltEch = (unsigned char)fValue;
          break;
        case (17):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].ucRadSurf = (unsigned char)fValue;
          break;
        case (18):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].usiInterpFlag = (unsigned short int)fValue;
          break;
        case (19):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].usiOrbitFlag = (unsigned short int)fValue;
          break;
        case (20):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].usiAltimStFlag = (unsigned short int)fValue;
          break;
        case (21):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].usiAltimDQFlag = (unsigned short int)fValue;
          break;
        case (22):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].usiAltimCQFlag = (unsigned short int)fValue;
          break;
        case (23):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].usiAltRainFlag = (unsigned short int)fValue;
          break;
        case (24):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].usiRadStatFlag = (unsigned short int)fValue;
          break;
        case (25):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].usiRadDQuaFlag = (unsigned short int)fValue;
          break;
        case (26):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].usiRadBTInFlag = (unsigned short int)fValue;
          break;
        case (27):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].usiIceFlag = (unsigned short int)fValue;
          break;
        case (28):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].ucAuxAltStatFlg = (unsigned char)fValue;
          break;
        case (29):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].ucMetMapAvl = (unsigned char)fValue;
          break;
        case (30):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].ucMDTInterpFlaf = (unsigned char)fValue;
          break;
        case (31):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fRangeKu = fValue;
          break;
        case (32):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fRMSRanKu = fValue;
          break;
        case (33):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fNumRanKu = fValue;
          break;
        case (34):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fInstCorrKu = fValue;
          break;
        case (35):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fSSBCorrKu = fValue;
          break;
        case (36):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fSWHKu = fValue;
          break;
        case (37):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fRMSSWHKu = fValue;
          break;
        case (38):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fNumSWHKu = fValue;
          break;
        case (39):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fInstCorrSWHKu = fValue;
          break;
        case (40):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fSig0Ku = fValue;
          break;
        case (41):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fRMSSig0Ku = fValue;
          break;
        case (42):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fNumSig0Ku = fValue;
          break;
        case (43):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fInstCorrSig0Ku = fValue;
          break;
        case (44):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fAtCorrSig0Ku = fValue;
          break;
        case (45):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fAGCKu = fValue;
          break;
        case (46):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fRMSAGCKu = fValue;
          break;
        case (47):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fNumAGCKu = fValue;
          break;
        case (48):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fRangeC = fValue;
          break;
        case (49):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fRMSRanC = fValue;
          break;
        case (50):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fNumRanC = fValue;
          break;
        case (51):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fInstCorrC = fValue;
          break;
        case (52):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fSSBCorrC = fValue;
          break;
        case (53):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fSWHC = fValue;
          break;
        case (54):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fRMSSWHC = fValue;
          break;
        case (55):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fNumSWHC = fValue;
          break;
        case (56):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fInstCorrSWHC = fValue;
          break;
        case (57):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fSig0C = fValue;
          break;
        case (58):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fRMSSig0C = fValue;
          break;
        case (59):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fNumSig0C = fValue;
          break;
        case (60):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fInstCorrSig0C = fValue;
          break;
        case (61):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fAtCorrSig0C = fValue;
          break;
        case (62):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fAGCC = fValue;
          break;
        case (63):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fRMSAGCC = fValue;
          break;
        case (64):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fNumAGCC = fValue;
          break;
        case (66):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fBT187 = fValue;
          break;
        case (68):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fBT238 = fValue;
          break;
        case (70):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fBT340 = fValue;
          break;
        case (71):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fRadWV = fValue;
          break;
        case (72):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fRadLW = fValue;
          break;
        case (74):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fWSpdAlt =fValue;
          break;
        case (75):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fWSpdRad = fValue;
          break;
        case (77):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fWSpdMU = fValue;
          break;
        case (78):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fWSpdMV = fValue;
          break;
        case (79):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fMeanDynTop = fValue;
          break;
        case (80):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fHeight =fValue;
          break;
        case (81):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fInstAltR = fValue;
          break;
        case (82):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fOffNadPtf = fValue;
          break;
        case (83):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fOffNadWv = fValue;
          break;
        case (84):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fModIonCor = fValue;
          break;
        case (85):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fAltIonCor =fValue;
          break;
        case (86):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fMDryTCor = fValue;
          break;
        case (87):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fMWetTCor = fValue;
          break;
        case (88):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fRadWetTCor = fValue;
          break;
        case (89):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fMSS = fValue;
          break;
        case (90):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fMSSAlt = fValue;
          break;
        case (91):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fGeoid = fValue;
          break;
        case (92):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
            psData[liSubSet].fBathy = fValue;
          break;
    	case (93):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
    	    psData[liSubSet].fSolidTide = fValue;
    	  break;
    	case (94):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
    	    psData[liSubSet].fGeoTide1 = fValue;
    	  break;
    	case (95):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
    	    psData[liSubSet].fGeoTide2 = fValue;
    	  break;
    	case (96):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
    	    psData[liSubSet].fLoadTide1 = fValue;
    	  break;
    	case (97):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
    	    psData[liSubSet].fLoadTide2 = fValue;
    	  break;
    	case (98):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
    	    psData[liSubSet].fOcTideEq = fValue;
    	  break;
    	case (99):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
    	    psData[liSubSet].fOcTideNonEq =fValue;
    	  break;
    	case (100):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
    	    psData[liSubSet].fPoleTide = fValue;
    	  break;
    	case (101):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
    	    psData[liSubSet].fInvBath = fValue;
    	  break;
    	case (102):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
    	    psData[liSubSet].fHfFluc = fValue;
    	  break;
    	case (103):
          for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
    	    psData[liSubSet].fSSHA = fValue;
    	  break;
        default:
          break; 
        }
      }
/* Otherwise read all the values */
      else
      {
        for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
        {
/* Read reference value (allow up to 64 bits) */
          liNumberN = *(pzWholeFile + liStartByte); unsign(liNumberN);
          liNumberO = *(pzWholeFile + liStartByte + 1); unsign(liNumberO);
          liNumberP = *(pzWholeFile + liStartByte + 2); unsign(liNumberP);
          liNumberQ = *(pzWholeFile + liStartByte + 3); unsign(liNumberQ);
          liNumberR = *(pzWholeFile + liStartByte + 4); unsign(liNumberR);
          liNumberS = *(pzWholeFile + liStartByte + 5); unsign(liNumberS);
          liNumberT = *(pzWholeFile + liStartByte + 6); unsign(liNumberT);
          liNumberU = *(pzWholeFile + liStartByte + 7); unsign(liNumberU);

          ullToilBits = ((unsigned long long)liNumberN * 256 * 256 * 256 * 256 * 256 * 256 * 256) +
                        ((unsigned long long)liNumberO * 256 * 256 * 256 * 256 * 256 * 256) +
                        ((unsigned long long)liNumberP * 256 * 256 * 256 * 256 * 256) +
                        ((unsigned long long)liNumberQ * 256 * 256 * 256 * 256) +
                        ((unsigned long long)liNumberR * 256 * 256 * 256) +
                        ((unsigned long long)liNumberS * 256 * 256) +
                        ((unsigned long long)liNumberT * 256) +
                         (unsigned long long)liNumberU;
          ullToilBits >>= (64 - ((shStartBit + shNBINC) - 1));
          ullToilBits = ullToilBits &
            ((unsigned long int)pow((double)2, (double)(shNBINC)) - 1);
/* IF missing value used set all possible bits to one */
          if (ullToilBits == ((unsigned long int)pow((double)2, (double)(shNBINC)) - 1))
          {
            fValue = ((unsigned long int)pow((double)2, (double)(shLocWidth)) - 1);
          }
/* ELSE add reference value from compression */
          else
          {
            fValue = (float)(ullToilBits + liR0);
          }
/* Add reference value from Table B */
          fValue += (float)(liLocRef);
/* Apply scale from Table B */
          fValue /= (float)pow((double)10, (double)(shLocScale));
/* Fill AVHRR info */
          switch (shElement)
          {
    	    case (0):
    	      psData[liSubSet].usiSatId = (unsigned short int)fValue;
    	      break;
    	    case (1):
    	      psData[liSubSet].usiSatInstr = (unsigned short int)fValue;
    	      break;
    	    case (2):
    	      psData[liSubSet].azAqunStatnId[0] = 'A';
    	      psData[liSubSet].azAqunStatnId[1] = '\0';
    	      break;
    	    case (3):
    	      psData[liSubSet].azSoftwareId[0] = 'B';
    	      psData[liSubSet].azSoftwareId[1] = '\0';
    	      break;
    	    case (4):
    	      psData[liSubSet].uliOrbit = (unsigned long int)fValue;
    	      break;
    	    case (5):
    	      psData[liSubSet].uliSatCycle = (unsigned long int)fValue;
    	      break;
    	    case (6):
    	      psData[liSubSet].azModelNum[0] = 'C';
    	      psData[liSubSet].azModelNum[1] = '\0';
    	      break;
    	    case (7):
    	      psData[liSubSet].shYear = (unsigned short int)fValue;
    	      break;
    	    case (8):
    	      psData[liSubSet].shMonth = (unsigned short int)fValue;
    	      break;
    	    case (9):
    	      psData[liSubSet].shDay = (unsigned short int)fValue;
    	      break;
    	    case (10):
    	      psData[liSubSet].shHour = (unsigned short int)fValue;
    	      break;
    	    case (11):
    	      psData[liSubSet].shMinute = (unsigned short int)fValue;
    	      break;
    	    case (12):
    	      psData[liSubSet].shSecond = (unsigned short int)fValue;
    	      break;
    	    case (13):
    	      psData[liSubSet].fLatitude = fValue;
    	      break;
    	    case (14):
    	      psData[liSubSet].fLongitude = fValue;
    	      break;
            case (15):
              psData[liSubSet].ucSurf = (unsigned char)fValue;
              break;
            case (16):
              psData[liSubSet].ucAltEch = (unsigned char)fValue;
              break;
            case (17):
              psData[liSubSet].ucRadSurf = (unsigned char)fValue;
              break;
            case (18):
              psData[liSubSet].usiInterpFlag = (unsigned short int)fValue;
              break;
            case (19):
              psData[liSubSet].usiOrbitFlag = (unsigned short int)fValue;
              break;
            case (20):
              psData[liSubSet].usiAltimStFlag = (unsigned short int)fValue;
              break;
            case (21):
              psData[liSubSet].usiAltimDQFlag = (unsigned short int)fValue;
              break;
            case (22):
              psData[liSubSet].usiAltimCQFlag = (unsigned short int)fValue;
              break;
            case (23):
              psData[liSubSet].usiAltRainFlag = (unsigned short int)fValue;
              break;
            case (24):
              psData[liSubSet].usiRadStatFlag = (unsigned short int)fValue;
              break;
            case (25):
              psData[liSubSet].usiRadDQuaFlag = (unsigned short int)fValue;
              break;
            case (26):
              psData[liSubSet].usiRadBTInFlag = (unsigned short int)fValue;
              break;
            case (27):
              psData[liSubSet].usiIceFlag = (unsigned short int)fValue;
              break;
            case (28):
              psData[liSubSet].ucAuxAltStatFlg = (unsigned char)fValue;
              break;
            case (29):
              psData[liSubSet].ucMetMapAvl = (unsigned char)fValue;
              break;
            case (30):
              psData[liSubSet].ucMDTInterpFlaf = (unsigned char)fValue;
              break;
            case (31):
              psData[liSubSet].fRangeKu = fValue;
              break;
            case (32):
              psData[liSubSet].fRMSRanKu = fValue;
              break;
            case (33):
              psData[liSubSet].fNumRanKu = fValue;
              break;
            case (34):
              psData[liSubSet].fInstCorrKu = fValue;
              break;
            case (35):
              psData[liSubSet].fSSBCorrKu = fValue;
              break;
            case (36):
              psData[liSubSet].fSWHKu = fValue;
              break;
            case (37):
              psData[liSubSet].fRMSSWHKu = fValue;
              break;
            case (38):
              psData[liSubSet].fNumSWHKu = fValue;
              break;
            case (39):
              psData[liSubSet].fInstCorrSWHKu = fValue;
              break;
            case (40):
              psData[liSubSet].fSig0Ku = fValue;
              break;
            case (41):
              psData[liSubSet].fRMSSig0Ku = fValue;
              break;
            case (42):
              psData[liSubSet].fNumSig0Ku = fValue;
              break;
            case (43):
              psData[liSubSet].fInstCorrSig0Ku = fValue;
              break;
            case (44):
              psData[liSubSet].fAtCorrSig0Ku = fValue;
              break;
            case (45):
              psData[liSubSet].fAGCKu = fValue;
              break;
            case (46):
              psData[liSubSet].fRMSAGCKu = fValue;
              break;
            case (47):
              psData[liSubSet].fNumAGCKu = fValue;
              break;
            case (48):
              psData[liSubSet].fRangeC = fValue;
              break;
            case (49):
              psData[liSubSet].fRMSRanC = fValue;
              break;
            case (50):
              psData[liSubSet].fNumRanC = fValue;
              break;
            case (51):
              psData[liSubSet].fInstCorrC = fValue;
              break;
            case (52):
              psData[liSubSet].fSSBCorrC = fValue;
              break;
            case (53):
              psData[liSubSet].fSWHC = fValue;
              break;
            case (54):
              psData[liSubSet].fRMSSWHC = fValue;
              break;
            case (55):
              psData[liSubSet].fNumSWHC = fValue;
              break;
            case (56):
              psData[liSubSet].fInstCorrSWHC = fValue;
              break;
            case (57):
              psData[liSubSet].fSig0C = fValue;
              break;
            case (58):
              psData[liSubSet].fRMSSig0C = fValue;
              break;
            case (59):
              psData[liSubSet].fNumSig0C = fValue;
              break;
            case (60):
              psData[liSubSet].fInstCorrSig0C = fValue;
              break;
            case (61):
              psData[liSubSet].fAtCorrSig0C = fValue;
              break;
            case (62):
              psData[liSubSet].fAGCC = fValue;
              break;
            case (63):
              psData[liSubSet].fRMSAGCC = fValue;
              break;
            case (64):
              psData[liSubSet].fNumAGCC = fValue;
              break;
     	    case (66):
     	      psData[liSubSet].fBT187 = fValue;
     	      break;
     	    case (68):
     	      psData[liSubSet].fBT238 = fValue;
     	      break;
     	    case (70):
     	      psData[liSubSet].fBT340 = fValue;
     	      break;
            case (71):
              psData[liSubSet].fRadWV = fValue;
              break;
            case (72):
              psData[liSubSet].fRadLW = fValue;
              break;
            case (74):
              psData[liSubSet].fWSpdAlt =fValue;
              break;
            case (75):
              psData[liSubSet].fWSpdRad = fValue;
              break;
            case (77):
              psData[liSubSet].fWSpdMU = fValue;
              break;
            case (78):
              psData[liSubSet].fWSpdMV = fValue;
              break;
    	    case (79):
    	      psData[liSubSet].fMeanDynTop = fValue;
    	      break;
    	    case (80):
    	      psData[liSubSet].fHeight =fValue;
    	      break;
    	    case (81):
    	      psData[liSubSet].fInstAltR = fValue;
    	      break;
    	    case (82):
    	      psData[liSubSet].fOffNadPtf = fValue;
    	      break;
    	    case (83):
    	      psData[liSubSet].fOffNadWv = fValue;
    	      break;
    	    case (84):
    	      psData[liSubSet].fModIonCor = fValue;
    	      break;
    	    case (85):
    	      psData[liSubSet].fAltIonCor =fValue;
    	      break;
    	    case (86):
    	      psData[liSubSet].fMDryTCor = fValue;
    	      break;
    	    case (87):
    	      psData[liSubSet].fMWetTCor = fValue;
    	      break;
    	    case (88):
    	      psData[liSubSet].fRadWetTCor = fValue;
    	      break;
            case (89):
              psData[liSubSet].fMSS = fValue;
              break;
            case (90):
              psData[liSubSet].fMSSAlt = fValue;
              break;
            case (91):
              psData[liSubSet].fGeoid = fValue;
              break;
            case (92):
              psData[liSubSet].fBathy = fValue;
              break;
    	    case (93):
    	      psData[liSubSet].fSolidTide = fValue;
    	      break;
    	    case (94):
    	      psData[liSubSet].fGeoTide1 = fValue;
    	      break;
    	    case (95):
    	      psData[liSubSet].fGeoTide2 = fValue;
    	      break;
    	    case (96):
    	      psData[liSubSet].fLoadTide1 = fValue;
    	      break;
    	    case (97):
    	      psData[liSubSet].fLoadTide2 = fValue;
    	      break;
    	    case (98):
    	      psData[liSubSet].fOcTideEq = fValue;
    	      break;
    	    case (99):
    	      psData[liSubSet].fOcTideNonEq =fValue;
    	      break;
    	    case (100):
    	      psData[liSubSet].fPoleTide = fValue;
    	      break;
    	    case (101):
    	      psData[liSubSet].fInvBath = fValue;
    	      break;
    	    case (102):
    	      psData[liSubSet].fHfFluc = fValue;
    	      break;
    	    case (103):
    	      psData[liSubSet].fSSHA = fValue;
    	      break;
            default:
              break; 
          }

/* Calculate end byte and bit */
          liEndByte = ((liStartByte * 8) + shStartBit + (shNBINC - 1)) / 8;
          shEndBit = ((liStartByte * 8) + shStartBit + (shNBINC - 1)) % 8;
          if (0 == shEndBit)
          {
            shEndBit = 8;
            liEndByte -= 1;
          }
/* Calculate next start byte and bit */
          liStartByte = liEndByte;
          shStartBit = shEndBit + 1;
          if (9 == shStartBit)
          {
            shStartBit = 1;
            liStartByte += 1;
          }
        }
      }
    }
  }
  else
  {
    (void)printf("Section 4 decoding not supported for these data.\n");
  }

  liSect5Offset = (liSect4Offset + liSect4Length);

  /* Section 5 */
  (void)printf("\nSection 5\n=========\n");

  (void)memcpy(pzFormat, pzWholeFile + liSect5Offset, 4);
  *(pzFormat + 4) = NULL;
  (void)printf("End sequence: %s\n",pzFormat); 

  (void)printf("\nJASON2 OGDR data\n===========\n");
  for (liSubSet = 0; liSubSet < liTotSubSets; liSubSet++)
  {
/*
    (void)printf("%3.3d %3.3d %4s %5ld %6ld ",
      psData[liSubSet].usiSatId,
      psData[liSubSet].usiSatInstr,
      psData[liSubSet].azAqunStatnId,
      psData[liSubSet].uliOrbit,
      psData[liSubSet].uliSatCycle
      );
*/
/*
    (void)printf("%4.4d/%2.2d/%2.2d %2.2d:%2.2d:%2.2d %7.2f %7.2f %4.4x %4.4x %4.4x %4.4x %4.4x %4.4x %4.4x %4.4x %4.4x %4.4x\n",
      psData[liSubSet].shYear,
      psData[liSubSet].shMonth,
      psData[liSubSet].shDay,
      psData[liSubSet].shHour,
      psData[liSubSet].shMinute,
      psData[liSubSet].shSecond,
      psData[liSubSet].fLatitude,
      psData[liSubSet].fLongitude,
      psData[liSubSet].usiInterpFlag,
      psData[liSubSet].usiOrbitFlag,
      psData[liSubSet].usiAltimStFlag,
      psData[liSubSet].usiAltimDQFlag,
      psData[liSubSet].usiAltimCQFlag,
      psData[liSubSet].usiAltRainFlag,
      psData[liSubSet].usiRadStatFlag,
      psData[liSubSet].usiRadDQuaFlag,
      psData[liSubSet].usiRadBTInFlag,
      psData[liSubSet].usiIceFlag
      );
*/
    (void)printf("%12.6f %12.6f %1.1d %1.1d %1.1d %10.3f\n",
      psData[liSubSet].fLongitude,
      psData[liSubSet].fLatitude,
      psData[liSubSet].ucAuxAltStatFlg,
      psData[liSubSet].ucMetMapAvl,
      psData[liSubSet].ucMDTInterpFlaf,
      psData[liSubSet].fSSHA
      );
/*
    (void)printf("%8.2f %8.2f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f\n",
      psData[liSubSet].fLatitude,
      psData[liSubSet].fLongitude,
      psData[liSubSet].fRangeKu,
      psData[liSubSet].fRMSRanKu,
      psData[liSubSet].fNumRanKu,
      psData[liSubSet].fInstCorrKu,
      psData[liSubSet].fSSBCorrKu,
      psData[liSubSet].fSWHKu,
      psData[liSubSet].fRMSSWHKu,
      psData[liSubSet].fNumSWHKu,
      psData[liSubSet].fInstCorrSWHKu,
      psData[liSubSet].fSig0Ku,
      psData[liSubSet].fRMSSig0Ku,
      psData[liSubSet].fNumSig0Ku,
      psData[liSubSet].fInstCorrSig0Ku,
      psData[liSubSet].fAtCorrSig0Ku,
      psData[liSubSet].fAGCKu,
      psData[liSubSet].fRMSAGCKu,
      psData[liSubSet].fNumAGCKu
      );
*/
/*
    (void)printf("%8.2f %8.2f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f\n",
      psData[liSubSet].fLatitude,
      psData[liSubSet].fLongitude,
      psData[liSubSet].fRangeC,
      psData[liSubSet].fRMSRanC,
      psData[liSubSet].fNumRanC,
      psData[liSubSet].fInstCorrC,
      psData[liSubSet].fSSBCorrC,
      psData[liSubSet].fSWHC,
      psData[liSubSet].fRMSSWHC,
      psData[liSubSet].fNumSWHC,
      psData[liSubSet].fInstCorrSWHC,
      psData[liSubSet].fSig0C,
      psData[liSubSet].fRMSSig0C,
      psData[liSubSet].fNumSig0C,
      psData[liSubSet].fInstCorrSig0C,
      psData[liSubSet].fAtCorrSig0C,
      psData[liSubSet].fAGCC,
      psData[liSubSet].fRMSAGCC,
      psData[liSubSet].fNumAGCC
      );
*/
/*
    (void)printf("%8.2f %8.2f %f %f %f %f %f %f %f %f %f %f %f %f %f %f\n",
      psData[liSubSet].fLatitude,
      psData[liSubSet].fLongitude,
      psData[liSubSet].fMSS,
      psData[liSubSet].fMSSAlt,
      psData[liSubSet].fGeoid,
      psData[liSubSet].fBathy,
      psData[liSubSet].fSolidTide,
      psData[liSubSet].fGeoTide1,
      psData[liSubSet].fGeoTide2,
      psData[liSubSet].fLoadTide1,
      psData[liSubSet].fLoadTide2,
      psData[liSubSet].fOcTideEq,
      psData[liSubSet].fOcTideNonEq,
      psData[liSubSet].fPoleTide,
      psData[liSubSet].fInvBath,
      psData[liSubSet].fHfFluc
      );
*/
/*
    (void)printf("%8.2f %8.2f %f\n",
      psData[liSubSet].fLatitude,
      psData[liSubSet].fLongitude,
      psData[liSubSet].fRadWV
      );
*/
  }

  /* Free up dynamic memory */
  free((void *)pzFormat);
  free((void *)pzWholeFile);
}
